/*********************************************************************/
/*                                                                   */
/*             Optimized BLAS libraries                              */
/*                     By Kazushige Goto <kgoto@tacc.utexas.edu>     */
/*                                                                   */
/* Copyright (c) The University of Texas, 2005. All rights reserved. */
/* UNIVERSITY EXPRESSLY DISCLAIMS ANY AND ALL WARRANTIES CONCERNING  */
/* THIS SOFTWARE AND DOCUMENTATION, INCLUDING ANY WARRANTIES OF      */
/* MERCHANTABILITY, FITNESS FOR ANY PARTICULAR PURPOSE,              */
/* NON-INFRINGEMENT AND WARRANTIES OF PERFORMANCE, AND ANY WARRANTY  */
/* THAT MIGHT OTHERWISE ARISE FROM COURSE OF DEALING OR USAGE OF     */
/* TRADE. NO WARRANTY IS EITHER EXPRESS OR IMPLIED WITH RESPECT TO   */
/* THE USE OF THE SOFTWARE OR DOCUMENTATION.                         */
/* Under no circumstances shall University be liable for incidental, */
/* special, indirect, direct or consequential damages or loss of     */
/* profits, interruption of business, or related expenses which may  */
/* arise from use of Software or Documentation, including but not    */
/* limited to those resulting from defects in Software and/or        */
/* Documentation, or loss or inaccuracy of data of any kind.         */
/*********************************************************************/

#define ASSEMBLER
#include "common.h"

#define M	ARG1	/* rdi */
#define X	ARG4	/* rsi */
#define INCX	ARG5	/* rdx */
#define Y	ARG6	/* rcx */
#define INCY	ARG2	/* r8  */
	
	PROLOGUE
	PROFCODE
	
	movslq	8(%rsp), INCY

	sub	$8, %rsp
	MOVSD	%xmm0, (%rsp)
	FLD	(%rsp)
	add	$8, %rsp

	leaq	(, INCX, SIZE), INCX
	leaq	(, INCY, SIZE), INCY

	cmpq	$SIZE, INCX
	jne	.L14
	cmpq	$SIZE, INCY
	jne	.L14

	movq	M, %rax
	sarq	$3,   %rax
	jle	.L15
	.align	8

#define PRESIZE 27

.L16:
#ifdef HAVE_3DNOW
	prefetchw	PRESIZE * SIZE(Y)
#endif
	
	FLD	1 * SIZE(X)
	FLD	0 * SIZE(X)
	fmul	%st(2), %st
	FADD	0 * SIZE(Y)
	FST	0 * SIZE(Y)
	fmul	%st(1),%st
	FADD	1 * SIZE(Y)
	FST	1 * SIZE(Y)

	FLD	3 * SIZE(X)
	FLD	2 * SIZE(X)
	fmul	%st(2),%st
	FADD	2 * SIZE(Y)
	FST	2 * SIZE(Y)
	fmul	%st(1),%st
	FADD	3 * SIZE(Y)
	FST	3 * SIZE(Y)

	prefetcht0	PRESIZE * SIZE(X)

	FLD	5 * SIZE(X)
	FLD	4 * SIZE(X)
	fmul	%st(2),%st
	FADD	4 * SIZE(Y)
	FST	4 * SIZE(Y)
	fmul	%st(1),%st
	FADD	5 * SIZE(Y)
	FST	5 * SIZE(Y)

	FLD	7 * SIZE(X)
	FLD	6 * SIZE(X)
	fmul	%st(2),%st
	FADD	6 * SIZE(Y)
	FST	6 * SIZE(Y)
	fmul	%st(1),%st
	FADD	7 * SIZE(Y)
	FST	7 * SIZE(Y)

	addq	$8 * SIZE, X
	addq	$8 * SIZE, Y
	decq	%rax
	jg	.L16
	.align 8

.L15:
	movq	M, %rax
	andq	$7,   %rax
	jle	.L40
	.align	8

.L22:
	FLD	0 * SIZE(X)
	fmul	%st(1),%st
	FADD	0 * SIZE(Y)
	FST	0 * SIZE(Y)
	addq	$SIZE, X
	addq	$SIZE, Y
	decq	%rax
	jg	.L22
	jmp	.L40
	.align	8

.L14:
	movq	M, %rax
	sarq	$2,   %rax
	jle	.L28
	.align	8

.L29:
	FLD	(X)
	fmul	%st(1),%st
	FADD	(Y)
	FST	(Y)
	addq	INCX, X
	addq	INCY, Y

	FLD	(X)
	fmul	%st(1),%st
	FADD	(Y)
	FST	(Y)
	addq	INCX, X
	addq	INCY, Y

	FLD	(X)
	fmul	%st(1),%st
	FADD	(Y)
	FST	(Y)
	addq	INCX, X
	addq	INCY, Y

	FLD	(X)
	fmul	%st(1),%st
	FADD	(Y)
	FST	(Y)
	addq	INCX, X
	addq	INCY, Y

	decq	%rax
	jg	.L29
	.align 8

.L28:
	movq	M, %rax
	andq	$3,   %rax
	jle	.L40
	.align	8

.L35:
	FLD	(X)
	fmul	%st(1),%st
	FADD	(Y)
	FST	(Y)
	addq	INCX, X
	addq	INCY, Y

	decq	%rax
	jg	.L35
	.align 8

.L40:
	ffreep	%st(0)
	xorq	%rax,%rax
	ret

	EPILOGUE
