/*********************************************************************/
/*                                                                   */
/*             Optimized BLAS libraries                              */
/*                     By Kazushige Goto <kgoto@tacc.utexas.edu>     */
/*                                                                   */
/* Copyright (c) The University of Texas, 2005. All rights reserved. */
/* UNIVERSITY EXPRESSLY DISCLAIMS ANY AND ALL WARRANTIES CONCERNING  */
/* THIS SOFTWARE AND DOCUMENTATION, INCLUDING ANY WARRANTIES OF      */
/* MERCHANTABILITY, FITNESS FOR ANY PARTICULAR PURPOSE,              */
/* NON-INFRINGEMENT AND WARRANTIES OF PERFORMANCE, AND ANY WARRANTY  */
/* THAT MIGHT OTHERWISE ARISE FROM COURSE OF DEALING OR USAGE OF     */
/* TRADE. NO WARRANTY IS EITHER EXPRESS OR IMPLIED WITH RESPECT TO   */
/* THE USE OF THE SOFTWARE OR DOCUMENTATION.                         */
/* Under no circumstances shall University be liable for incidental, */
/* special, indirect, direct or consequential damages or loss of     */
/* profits, interruption of business, or related expenses which may  */
/* arise from use of Software or Documentation, including but not    */
/* limited to those resulting from defects in Software and/or        */
/* Documentation, or loss or inaccuracy of data of any kind.         */
/*********************************************************************/

#define ASSEMBLER
#include "common.h"

#define M	ARG1
#define X	ARG4
#define INCX	ARG5

#define I	%rsi
#define XX	%rdx

	PROLOGUE
	PROFCODE

	pxor	%xmm15, %xmm15
	salq	$ZBASE_SHIFT, INCX
	COMISD	%xmm0, %xmm15
	jne	.L300		# Alpha_r != ZERO
	COMISD	%xmm1, %xmm15
	jne	.L300		# Alpha_i != ZERO

/* Alpha == ZERO */
	cmpq	$2 * SIZE, INCX
	jne	.L104

	movq	M,  I	# rcx = n
	sarq	$3, I	# (n >> 3)
	jle	.L102
	.align 16

.L101:
#ifdef HAVE_3DNOW
	prefetchw	88 * SIZE(X)
#endif
	
#ifdef DOUBLE
	movsd	%xmm15,  0 * SIZE(X)
	movsd	%xmm15,  1 * SIZE(X)
	movsd	%xmm15,  2 * SIZE(X)
	movsd	%xmm15,  3 * SIZE(X)
	movsd	%xmm15,  4 * SIZE(X)
	movsd	%xmm15,  5 * SIZE(X)
	movsd	%xmm15,  6 * SIZE(X)
	movsd	%xmm15,  7 * SIZE(X)
	movsd	%xmm15,  8 * SIZE(X)
	movsd	%xmm15,  9 * SIZE(X)
	movsd	%xmm15, 10 * SIZE(X)
	movsd	%xmm15, 11 * SIZE(X)
	movsd	%xmm15, 12 * SIZE(X)
	movsd	%xmm15, 13 * SIZE(X)
	movsd	%xmm15, 14 * SIZE(X)
	movsd	%xmm15, 15 * SIZE(X)
#else
	movsd	%xmm15,  0 * SIZE(X)
	movsd	%xmm15,  2 * SIZE(X)
	movsd	%xmm15,  4 * SIZE(X)
	movsd	%xmm15,  6 * SIZE(X)
	movsd	%xmm15,  8 * SIZE(X)
	movsd	%xmm15, 10 * SIZE(X)
	movsd	%xmm15, 12 * SIZE(X)
	movsd	%xmm15, 14 * SIZE(X)
#endif

	addq	$16 * SIZE, X
	decq	I
	jg	.L101
	.align 16

.L102:
	movq	M,  I
	andq	$7, I
	jle	.L999
	.align 16

.L103:
#ifdef DOUBLE
	movsd	%xmm15,  0 * SIZE(X)
	movsd	%xmm15,  1 * SIZE(X)
#else
	movsd	%xmm15,  0 * SIZE(X)
#endif
	addq	$2 * SIZE, X
	decq	I
	jg	.L103
	jmp	.L999
	.align 16

.L104:
	movq	M,  I		# rcx = n
	sarq	$3, I		# (n >> 3)
	jle	.L106
	.align 16

.L105:
#ifdef DOUBLE
	MOVSD	%xmm15, 0 * SIZE(X)
	MOVSD	%xmm15, 1 * SIZE(X)
	addq	INCX, X
	MOVSD	%xmm15, 0 * SIZE(X)
	MOVSD	%xmm15, 1 * SIZE(X)
	addq	INCX, X
	MOVSD	%xmm15, 0 * SIZE(X)
	MOVSD	%xmm15, 1 * SIZE(X)
	addq	INCX, X
	MOVSD	%xmm15, 0 * SIZE(X)
	MOVSD	%xmm15, 1 * SIZE(X)
	addq	INCX, X
	MOVSD	%xmm15, 0 * SIZE(X)
	MOVSD	%xmm15, 1 * SIZE(X)
	addq	INCX, X
	MOVSD	%xmm15, 0 * SIZE(X)
	MOVSD	%xmm15, 1 * SIZE(X)
	addq	INCX, X
	MOVSD	%xmm15, 0 * SIZE(X)
	MOVSD	%xmm15, 1 * SIZE(X)
	addq	INCX, X
	MOVSD	%xmm15, 0 * SIZE(X)
	MOVSD	%xmm15, 1 * SIZE(X)
	addq	INCX, X
#else
	movsd	%xmm15, 0 * SIZE(X)
	addq	INCX, X
	movsd	%xmm15, 0 * SIZE(X)
	addq	INCX, X
	movsd	%xmm15, 0 * SIZE(X)
	addq	INCX, X
	movsd	%xmm15, 0 * SIZE(X)
	addq	INCX, X
	movsd	%xmm15, 0 * SIZE(X)
	addq	INCX, X
	movsd	%xmm15, 0 * SIZE(X)
	addq	INCX, X
	movsd	%xmm15, 0 * SIZE(X)
	addq	INCX, X
	movsd	%xmm15, 0 * SIZE(X)
	addq	INCX, X
#endif

	decq	I
	jg	.L105
	.align 16

.L106:
	movq	M, I
	andq	$7,   I
	jle	.L999
	.align 16

.L107:
#ifdef DOUBLE
	MOVSD	%xmm15, 0 * SIZE(X)
	MOVSD	%xmm15, 1 * SIZE(X)
#else
	movsd	%xmm15, 0 * SIZE(X)
#endif
	addq	INCX, X
	decq	I
	jg	.L107
	jmp	.L999
	.align 16

/* Alpha != ZERO */

.L300:
	cmpq	$2 * SIZE, INCX
	jne	.L304

	movq	M,  I		# rcx = n
	sarq	$2, I		# (n >> 3)
	jle	.L302
	.align 16

.L301:
#ifdef HAVE_3DNOW
	prefetchw	40 * SIZE(X)
#endif
	
	MOVSD	0 * SIZE(X), %xmm2
	MOVSD	1 * SIZE(X), %xmm3
	MULSD	%xmm0, %xmm2
	MULSD	%xmm1, %xmm3
	MOVSD	0 * SIZE(X), %xmm4
	MOVSD	1 * SIZE(X), %xmm5
	MULSD	%xmm1, %xmm4
	MULSD	%xmm0, %xmm5
	SUBSD	%xmm3, %xmm2
	ADDSD	%xmm5, %xmm4
	MOVSD	%xmm2, 0 * SIZE(X)
	MOVSD	%xmm4, 1 * SIZE(X)

	MOVSD	2 * SIZE(X), %xmm2
	MOVSD	3 * SIZE(X), %xmm3
	MULSD	%xmm0, %xmm2
	MULSD	%xmm1, %xmm3
	MOVSD	2 * SIZE(X), %xmm4
	MOVSD	3 * SIZE(X), %xmm5
	MULSD	%xmm1, %xmm4
	MULSD	%xmm0, %xmm5
	SUBSD	%xmm3, %xmm2
	ADDSD	%xmm5, %xmm4
	MOVSD	%xmm2, 2 * SIZE(X)
	MOVSD	%xmm4, 3 * SIZE(X)

	MOVSD	4 * SIZE(X), %xmm2
	MOVSD	5 * SIZE(X), %xmm3
	MULSD	%xmm0, %xmm2
	MULSD	%xmm1, %xmm3
	MOVSD	4 * SIZE(X), %xmm4
	MOVSD	5 * SIZE(X), %xmm5
	MULSD	%xmm1, %xmm4
	MULSD	%xmm0, %xmm5
	SUBSD	%xmm3, %xmm2
	ADDSD	%xmm5, %xmm4
	MOVSD	%xmm2, 4 * SIZE(X)
	MOVSD	%xmm4, 5 * SIZE(X)

	MOVSD	6 * SIZE(X), %xmm2
	MOVSD	7 * SIZE(X), %xmm3
	MULSD	%xmm0, %xmm2
	MULSD	%xmm1, %xmm3
	MOVSD	6 * SIZE(X), %xmm4
	MOVSD	7 * SIZE(X), %xmm5
	MULSD	%xmm1, %xmm4
	MULSD	%xmm0, %xmm5
	SUBSD	%xmm3, %xmm2
	ADDSD	%xmm5, %xmm4
	MOVSD	%xmm2, 6 * SIZE(X)
	MOVSD	%xmm4, 7 * SIZE(X)

	addq	$8 * SIZE, X
	decq	I
	jg	.L301
	.align 16

.L302:
	movq	M,  I
	andq	$3, I
	jle	.L999
	.align 16

.L303:
	MOVSD	0 * SIZE(X), %xmm2
	MOVSD	1 * SIZE(X), %xmm3
	MULSD	%xmm0, %xmm2
	MULSD	%xmm1, %xmm3
	MOVSD	0 * SIZE(X), %xmm4
	MOVSD	1 * SIZE(X), %xmm5
	MULSD	%xmm1, %xmm4
	MULSD	%xmm0, %xmm5
	SUBSD	%xmm3, %xmm2
	ADDSD	%xmm5, %xmm4
	MOVSD	%xmm2, 0 * SIZE(X)
	MOVSD	%xmm4, 1 * SIZE(X)

	addq	$2 * SIZE, X
	decq	I
	jg	.L303
	jmp	.L999
	.align 16

.L304:
	movq	X, XX
	movq	M,  I		# rcx = n
	sarq	$2, I		# (n >> 3)
	jle	.L306
	.align 16

.L305:
	MOVSD	0 * SIZE(X), %xmm2
	MOVSD	1 * SIZE(X), %xmm3
	MULSD	%xmm0, %xmm2
	MULSD	%xmm1, %xmm3
	MOVSD	0 * SIZE(X), %xmm4
	MOVSD	1 * SIZE(X), %xmm5
	MULSD	%xmm1, %xmm4
	MULSD	%xmm0, %xmm5
	SUBSD	%xmm3, %xmm2
	ADDSD	%xmm5, %xmm4
	MOVSD	%xmm2, 0 * SIZE(X)
	MOVSD	%xmm4, 1 * SIZE(X)
	addq	INCX, X

	MOVSD	0 * SIZE(X), %xmm2
	MOVSD	1 * SIZE(X), %xmm3
	MULSD	%xmm0, %xmm2
	MULSD	%xmm1, %xmm3
	MOVSD	0 * SIZE(X), %xmm4
	MOVSD	1 * SIZE(X), %xmm5
	MULSD	%xmm1, %xmm4
	MULSD	%xmm0, %xmm5
	SUBSD	%xmm3, %xmm2
	ADDSD	%xmm5, %xmm4
	MOVSD	%xmm2, 0 * SIZE(X)
	MOVSD	%xmm4, 1 * SIZE(X)
	addq	INCX, X

	MOVSD	0 * SIZE(X), %xmm2
	MOVSD	1 * SIZE(X), %xmm3
	MULSD	%xmm0, %xmm2
	MULSD	%xmm1, %xmm3
	MOVSD	0 * SIZE(X), %xmm4
	MOVSD	1 * SIZE(X), %xmm5
	MULSD	%xmm1, %xmm4
	MULSD	%xmm0, %xmm5
	SUBSD	%xmm3, %xmm2
	ADDSD	%xmm5, %xmm4
	MOVSD	%xmm2, 0 * SIZE(X)
	MOVSD	%xmm4, 1 * SIZE(X)
	addq	INCX, X

	MOVSD	0 * SIZE(X), %xmm2
	MOVSD	1 * SIZE(X), %xmm3
	MULSD	%xmm0, %xmm2
	MULSD	%xmm1, %xmm3
	MOVSD	0 * SIZE(X), %xmm4
	MOVSD	1 * SIZE(X), %xmm5
	MULSD	%xmm1, %xmm4
	MULSD	%xmm0, %xmm5
	SUBSD	%xmm3, %xmm2
	ADDSD	%xmm5, %xmm4
	MOVSD	%xmm2, 0 * SIZE(X)
	MOVSD	%xmm4, 1 * SIZE(X)
	addq	INCX, X

	decq	I
	jg	.L305
	.align 16

.L306:
	movq	M, I
	andq	$3,   I
	jle	.L999
	.align 16

.L307:
	MOVSD	0 * SIZE(X), %xmm2
	MOVSD	1 * SIZE(X), %xmm3
	MULSD	%xmm0, %xmm2
	MULSD	%xmm1, %xmm3
	MOVSD	0 * SIZE(X), %xmm4
	MOVSD	1 * SIZE(X), %xmm5
	MULSD	%xmm1, %xmm4
	MULSD	%xmm0, %xmm5
	SUBSD	%xmm3, %xmm2
	ADDSD	%xmm5, %xmm4
	MOVSD	%xmm2, 0 * SIZE(X)
	MOVSD	%xmm4, 1 * SIZE(X)

	addq	INCX, X
	decq	I
	jg	.L307
	.align 16

.L999:
	xorq	%rax, %rax
	ret

	EPILOGUE
