/*********************************************************************/
/*                                                                   */
/*             Optimized BLAS libraries                              */
/*                     By Kazushige Goto <kgoto@tacc.utexas.edu>     */
/*                                                                   */
/* Copyright (c) The University of Texas, 2005. All rights reserved. */
/* UNIVERSITY EXPRESSLY DISCLAIMS ANY AND ALL WARRANTIES CONCERNING  */
/* THIS SOFTWARE AND DOCUMENTATION, INCLUDING ANY WARRANTIES OF      */
/* MERCHANTABILITY, FITNESS FOR ANY PARTICULAR PURPOSE,              */
/* NON-INFRINGEMENT AND WARRANTIES OF PERFORMANCE, AND ANY WARRANTY  */
/* THAT MIGHT OTHERWISE ARISE FROM COURSE OF DEALING OR USAGE OF     */
/* TRADE. NO WARRANTY IS EITHER EXPRESS OR IMPLIED WITH RESPECT TO   */
/* THE USE OF THE SOFTWARE OR DOCUMENTATION.                         */
/* Under no circumstances shall University be liable for incidental, */
/* special, indirect, direct or consequential damages or loss of     */
/* profits, interruption of business, or related expenses which may  */
/* arise from use of Software or Documentation, including but not    */
/* limited to those resulting from defects in Software and/or        */
/* Documentation, or loss or inaccuracy of data of any kind.         */
/*********************************************************************/

#define ASSEMBLER
#include "common.h"

#define N	ARG1	/* rdi */
#define X	ARG4
#define INCX	ARG5
#define Y	ARG6
#define INCY	%rsi

#define XX	%r10
#define YY	%r11

	PROLOGUE
	PROFCODE
	
	movq	8(%rsp), INCY

	EMMS

	salq	$ZBASE_SHIFT, INCX
	salq	$ZBASE_SHIFT, INCY

	cmpq	$2 * SIZE, INCX
	jne	.L14
	cmpq	$2 * SIZE, INCY
	jne	.L14

	movq	N,  %rax
	sarq	$1, %rax
	jle	.L15
	.align	8

.L16:
#ifdef DOUBLE
	MOVQ	0 * SIZE(X), %mm0
	MOVQ	1 * SIZE(X), %mm1
	MOVQ	2 * SIZE(X), %mm2
	MOVQ	3 * SIZE(X), %mm3
	MOVQ	0 * SIZE(Y), %mm4
	MOVQ	1 * SIZE(Y), %mm5
	MOVQ	2 * SIZE(Y), %mm6
	MOVQ	3 * SIZE(Y), %mm7

	MOVQ	%mm4, 0 * SIZE(X)
	MOVQ	%mm5, 1 * SIZE(X)
	MOVQ	%mm6, 2 * SIZE(X)
	MOVQ	%mm7, 3 * SIZE(X)
	MOVQ	%mm0, 0 * SIZE(Y)
	MOVQ	%mm1, 1 * SIZE(Y)
	MOVQ	%mm2, 2 * SIZE(Y)
	MOVQ	%mm3, 3 * SIZE(Y)
#else
	movq	0 * SIZE(X), %mm0
	movq	2 * SIZE(X), %mm2
	movq	0 * SIZE(Y), %mm4
	movq	2 * SIZE(Y), %mm6

	movq	%mm4, 0 * SIZE(X)
	movq	%mm6, 2 * SIZE(X)
	movq	%mm0, 0 * SIZE(Y)
	movq	%mm2, 2 * SIZE(Y)
#endif

	addq	$4 * SIZE, X
	addq	$4 * SIZE, Y
	decq	%rax
	jg	.L16
	.align	8

.L15:
	movq	N, %rax
	andq	$1, %rax
	jle	.L27
	.align	8

.L22:
#ifdef DOUBLE
	MOVQ	0 * SIZE(X), %mm0
	MOVQ	1 * SIZE(X), %mm1
	MOVQ	0 * SIZE(Y), %mm4
	MOVQ	1 * SIZE(Y), %mm5
	MOVQ	%mm4, 0 * SIZE(X)
	MOVQ	%mm5, 1 * SIZE(X)
	MOVQ	%mm0, 0 * SIZE(Y)
	MOVQ	%mm1, 1 * SIZE(Y)
#else
	movq	0 * SIZE(X), %mm0
	movq	0 * SIZE(Y), %mm4
	movq	%mm4, 0 * SIZE(X)
	movq	%mm0, 0 * SIZE(Y)
#endif
	addq	$2 * SIZE, X
	addq	$2 * SIZE, Y
	decq	%rax
	jg	.L22
	jmp	.L27
	.align	8

/* INCX != 1 or INCY != 1 */

.L14:
	movq	N, %rax
	movq	X, XX
	movq	Y, YY
	sarq	$1,   %rax
	jle	.L28
	.align	4

.L29:
#ifdef DOUBLE
	MOVQ	0 * SIZE(X), %mm0
	MOVQ	1 * SIZE(X), %mm1
	addq	INCX, X
	MOVQ	0 * SIZE(X), %mm2
	MOVQ	1 * SIZE(X), %mm3
	addq	INCX, X

	MOVQ	0 * SIZE(Y), %mm4
	MOVQ	1 * SIZE(Y), %mm5
	addq	INCY, Y
	MOVQ	0 * SIZE(Y), %mm6
	MOVQ	1 * SIZE(Y), %mm7
	addq	INCY, Y

	MOVQ	%mm4, 0 * SIZE(XX)
	MOVQ	%mm5, 1 * SIZE(XX)
	addq	INCX, XX
	MOVQ	%mm6, 0 * SIZE(XX)
	MOVQ	%mm7, 1 * SIZE(XX)
	addq	INCX, XX

	MOVQ	%mm0, 0 * SIZE(YY)
	MOVQ	%mm1, 1 * SIZE(YY)
	addq	INCY, YY
	MOVQ	%mm2, 0 * SIZE(YY)
	MOVQ	%mm3, 1 * SIZE(YY)
	addq	INCY, YY
#else
	movq	0 * SIZE(X), %mm0
	addq	INCX, X
	movq	0 * SIZE(X), %mm2
	addq	INCX, X

	movq	0 * SIZE(Y), %mm4
	addq	INCY, Y
	movq	0 * SIZE(Y), %mm6
	addq	INCY, Y

	movq	%mm4, 0 * SIZE(XX)
	addq	INCX, XX
	movq	%mm6, 0 * SIZE(XX)
	addq	INCX, XX

	movq	%mm0, 0 * SIZE(YY)
	addq	INCY, YY
	movq	%mm2, 0 * SIZE(YY)
	addq	INCY, YY
#endif
	decq	%rax
	jg	.L29
	.align 8

.L28:
	movq	N, %rax
	andq	$1,   %rax
	jle	.L27
	.align	8

.L35:
#ifdef DOUBLE
	MOVQ	0 * SIZE(X), %mm0
	MOVQ	1 * SIZE(X), %mm1
	MOVQ	0 * SIZE(Y), %mm4
	MOVQ	1 * SIZE(Y), %mm5

	MOVQ	%mm4, 0 * SIZE(X)
	MOVQ	%mm5, 1 * SIZE(X)
	addq	INCX, X
	MOVQ	%mm0, 0 * SIZE(Y)
	MOVQ	%mm1, 1 * SIZE(Y)
	addq	INCY, Y
#else
	movq	0 * SIZE(X), %mm0
	movq	0 * SIZE(Y), %mm4
	movq	%mm4, 0 * SIZE(X)
	addq	INCX, X
	movq	%mm0, 0 * SIZE(Y)
	addq	INCY, Y
#endif
	decq	%rax
	jg	.L35
	.align 8

.L27:
	EMMS
	xorq	%rax,%rax
	ret

	EPILOGUE
