    /*        Fast HERK routine for Alpha 21164/21264      */
    /*         on  Linux, Digital UNIX                     */
    /*        by Kazushige Goto <goto@statabo.rim.or.jp>   */

#include <stdio.h>
#include <ctype.h>
#include "common.h"

int CNAME(long dummy1, long n,  long dummy2, FLOAT alpha_r, FLOAT alpha_i,
	      FLOAT *dummy3, long dummy4, FLOAT *dummy5, long dummy6,
	      FLOAT *c, long ldc, FLOAT *buffer, long from, long to){

  long i;

#ifndef LOWER
  for (i = from; i < to; i++){
    SCAL_K(i * 2, 0, 0, alpha_r, c + i * ldc * 2, 1, NULL, 0, NULL, 0);
    if (alpha_r == ZERO ){
      c[i * 2 + 0 + i * ldc * 2] = ZERO;
      c[i * 2 + 1 + i * ldc * 2] = ZERO;
    } else {
      c[i * 2 + 0 + i * ldc * 2] *= alpha_r;
      c[i * 2 + 1 + i * ldc * 2] = ZERO;
    }
  }
#else
  for (i = from; i < to; i++){
    if (alpha_r == ZERO) {
      c[i * 2 + 0 + i * ldc * 2] = ZERO;
      c[i * 2 + 1 + i * ldc * 2] = ZERO;
    } else {
      c[i * 2 + 0 + i * ldc * 2] *= alpha_r;
      c[i * 2 + 1 + i * ldc * 2] = ZERO;
    }
    SCAL_K((n - i - 1) * 2, 0, 0, alpha_r, c + 2 + i * (ldc + 1) * 2, 1, NULL, 0, NULL, 0);
  }
#endif

  return 0;
}
